package com.alibaba.druid.sql.ast.statement;

import com.alibaba.druid.DbType;
import com.alibaba.druid.sql.ast.SQLCommentHint;
import com.alibaba.druid.sql.ast.SQLExpr;
import com.alibaba.druid.sql.ast.SQLName;
import com.alibaba.druid.sql.ast.SQLStatementImpl;
import com.alibaba.druid.sql.visitor.SQLASTVisitor;
import java.util.ArrayList;
import java.util.List;

public class SQLDropTableStatement extends SQLStatementImpl implements SQLDropStatement {
   private List<SQLCommentHint> hints;
   protected List<SQLExprTableSource> tableSources;
   protected boolean purge;
   protected boolean cascade;
   protected boolean restrict;
   protected boolean ifExists;
   private boolean temporary;
   private boolean external;
   private boolean isDropPartition;
   private SQLExpr where;

   public SQLDropTableStatement() {
      this.tableSources = new ArrayList();
      this.cascade = false;
      this.restrict = false;
      this.ifExists = false;
      this.temporary = false;
      this.external = false;
   }

   public SQLDropTableStatement(DbType dbType) {
      super(dbType);
      this.tableSources = new ArrayList();
      this.cascade = false;
      this.restrict = false;
      this.ifExists = false;
      this.temporary = false;
      this.external = false;
   }

   public SQLDropTableStatement(SQLName name, DbType dbType) {
      this(new SQLExprTableSource(name), dbType);
   }

   public SQLDropTableStatement(SQLName name) {
      this((SQLName)name, (DbType)null);
   }

   public SQLDropTableStatement(SQLExprTableSource tableSource) {
      this((SQLExprTableSource)tableSource, (DbType)null);
   }

   public SQLDropTableStatement(SQLExprTableSource tableSource, DbType dbType) {
      this(dbType);
      this.tableSources.add(tableSource);
   }

   public List<SQLExprTableSource> getTableSources() {
      return this.tableSources;
   }

   public void addPartition(SQLExprTableSource tableSource) {
      if (tableSource != null) {
         tableSource.setParent(this);
      }

      this.tableSources.add(tableSource);
   }

   public void setName(SQLName name) {
      this.addTableSource(new SQLExprTableSource(name));
   }

   public void addTableSource(SQLName name) {
      this.addTableSource(new SQLExprTableSource(name));
   }

   public void addTableSource(SQLExprTableSource tableSource) {
      this.tableSources.add(tableSource);
   }

   protected void accept0(SQLASTVisitor visitor) {
      if (visitor.visit(this)) {
         this.acceptChild(visitor, this.tableSources);
      }

      visitor.endVisit(this);
   }

   public List getChildren() {
      return this.tableSources;
   }

   public boolean isPurge() {
      return this.purge;
   }

   public void setPurge(boolean purge) {
      this.purge = purge;
   }

   public boolean isIfExists() {
      return this.ifExists;
   }

   public void setIfExists(boolean ifExists) {
      this.ifExists = ifExists;
   }

   public boolean isCascade() {
      return this.cascade;
   }

   public void setCascade(boolean cascade) {
      this.cascade = cascade;
   }

   public boolean isRestrict() {
      return this.restrict;
   }

   public void setRestrict(boolean restrict) {
      this.restrict = restrict;
   }

   public boolean isTemporary() {
      return this.temporary;
   }

   public void setTemporary(boolean temporary) {
      this.temporary = temporary;
   }

   public boolean isExternal() {
      return this.external;
   }

   public void setExternal(boolean external) {
      this.external = external;
   }

   public List<SQLCommentHint> getHints() {
      return this.hints;
   }

   public void setHints(List<SQLCommentHint> hints) {
      this.hints = hints;
   }

   public boolean isDropPartition() {
      return this.isDropPartition;
   }

   public void setDropPartition(boolean dropPartition) {
      this.isDropPartition = dropPartition;
   }

   public SQLExpr getWhere() {
      return this.where;
   }

   public void setWhere(SQLExpr x) {
      if (x != null) {
         x.setParent(this);
      }

      this.where = x;
   }
}
